/*
 Copyright (C) 2013 Lukasz Nidecki SQ5RWU
 Edit RA4FHE xDD 2015
 1.Добавленно кол-принимаемых спутников	
 2.Вольтметр        (A0)  
 3.Термометр DS1820 (D6)
 */

#include <string.h>
#include <Arduino.h>
#include <ArduinoQAPRS.h>
#include <SPI.h>
#include <OneWire.h>

OneWire  ds(6);
char * packet_buffer  = "                                                                                    \n ";
char floatbuf[32];
char gradbuf[4];
char from_addr[] = "RA4FHE";      // Позывной
char dest_addr[] = "APZ058";     // Адрес
char relays[] = "WIDE2 2";       // Путь 
const int analogInPin = A0;
float sensorValue = 0;   
float outputValue = 0;  

String lat,lon,ns,ew;
String aprs = "";
String GPSStringbuf = "";
String GPSString = "";
int ledPin = 13;                  
int status,alti,sat,temp; 
boolean stringComplete = false;


void setup()
{
  Serial.begin(9600);            // Скорость порта GPS 
  Serial.println("WAIT!");
  delay(100);
  pinMode(ledPin, OUTPUT);       
  GPSString.reserve(100);        
  QAPRS.init(3,2);
  delay(2000); 
}

void loop()
{
  while (Serial.available()) 
  {
    char inChar = (char)Serial.read(); 
    GPSString += inChar;
    if (inChar == '\n') {
      stringComplete = true;
    }
  }
  if (stringComplete) 
  {    
    if(GPSString.indexOf("$GPGGA") != -1) 
    {

      //----------------Широта-----------------------------------------------      
      GPSStringbuf = GPSString.substring(position(2), position(3) - 1); 
      lat = GPSStringbuf.substring(0,7);

      //----------------Направление NS---------------------------------------      
      GPSStringbuf = GPSString.substring(position(3), position(4) - 1); 
      ns = GPSStringbuf;

      //----------------Долгота----------------------------------------------                  
      GPSStringbuf = GPSString.substring(position(4), position(5) - 1); 
      lon = GPSStringbuf.substring(0,8);

      //----------------Направление EW--------------------------------------      
      GPSStringbuf = GPSString.substring(position(5), position(6) - 1); 
      ew = GPSStringbuf;

      //----------------Качество приёма сигнала------------------------------
      GPSStringbuf = GPSString.substring(position(6), position(7) - 1); 
      GPSStringbuf.toCharArray(floatbuf, sizeof(floatbuf)); 
      status = atoi(floatbuf); 

      //----------------Количество принимаемых спутников-------------------
      GPSStringbuf = GPSString.substring(position(7), position(8) - 1); 
      GPSStringbuf.toCharArray(floatbuf, sizeof(floatbuf)); 
      sat = atoi(floatbuf);      

      //----------------Высота в футтах--------------------------------------
      GPSStringbuf = GPSString.substring(position(9), position(10) - 1); 
      GPSStringbuf.toCharArray(floatbuf, sizeof(floatbuf)); 

      alti = (atoi(floatbuf))*3.2808398950131;     

      if(status >=1) { 
        delay(100);
        sensorValue = analogRead(analogInPin); 
        outputValue = float(analogRead(analogInPin))/204.6;
        outputValue = (outputValue) * 10;

        {
          byte i;
          byte present = 0;
          byte data[12];
          byte addr[8];  
          if ( !ds.search(addr)) {
            ds.reset_search();
            return;
          }  

          if ( OneWire::crc8( addr, 7) != addr[7]) {
            return;
          }

          if ( addr[0] != 0x10) {
            return;
          }

          ds.reset();
          ds.select(addr);
          ds.write(0x44,1); 
          delay(1000);
          present = ds.reset();
          ds.select(addr);    
          ds.write(0xBE);

          for ( i = 0; i < 9; i++) {
            data[i] = ds.read();
          }

          int HighByte, LowByte, TReading, Tce;
          LowByte = data[0];
          HighByte = data[1];
          TReading = (HighByte << 8) + LowByte; 
          Tce = TReading/2;
          temp = (Tce);
        }


        // Строка для отсылки пакета APRS 
        aprs = "!" + lat + ns + "/" + lon + ew + "P" + "/A=000" + alti + " Bat=" + outputValue + "V" + " Sat=" + sat + " Temp=" + temp + "C" + " http://infotex58.ru";


        // convert string to char_array
        int str_len = aprs.length() + 1; 
        char char_array[str_len];
        aprs.toCharArray(char_array, str_len);

        // send via packet_buffer 
        packet_buffer = char_array;
        Serial.print("Send:    "),Serial.println(packet_buffer); 
        QAPRS.send(from_addr, '9', dest_addr, '0', relays, packet_buffer);    // SSID-9

      }

      { 
        delay(21000); // Пауза посылки пакетов
      }     
    }
    GPSString = "";
    GPSStringbuf = "";
    stringComplete = false;
  }
}

int position(int number) 
{
  int i = 0;
  int position = 0;
  while(i < number)
  {
    position = GPSString.indexOf(",", position) + 1; 
    i++;
  }
  return position;
}

